<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: shop-cart.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: shop-cart.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>const totalTable = document.querySelector('table')
const table = document.querySelector('tbody')
const showFormButton = document.querySelector('#fake-button')
const showTotalPrice = document.querySelector('tfoot')
const products = []
const emptyCartButton = document.getElementById('empty-cart-button')
const emptyCartText = document.getElementById('empty-cart-text')

const firstNameInput = document.querySelector("#firstname")
const lastNameInput = document.querySelector("#lastname")
const mailInput = document.querySelector("#mail")
const addressInput = document.querySelector("#address")
const postalInput = document.querySelector("#postal")
const cityInput = document.querySelector("#city")
const phoneInput = document.querySelector("#phone")

const regexFirstName = /^[a-zA-Z- ]+$/
const regexLastName = /^[a-zA-Z-]+$/
const regexMail = /\S+@\S+\.\S+/
const regexAddress = /[a-zA-Z0-9- ]{8}/
const regexPostal = /[0-9]{5}/
const regexCity = /^[a-zA-Z- ]{6}/

const allImg = document.querySelectorAll('.icone-verif')
const allSpan = document.querySelectorAll('span')

/**
 * Fonction qui permet de vider le panier
 */
function deleteItems() {
    sessionStorage.clear()
    totalTable.innerText = ""
    emptyCartText.classList.remove('d-none')
    showFormButton.classList.add('d-none')
    emptyCartButton.classList.add('d-none')
}

/**
 * Fonction qui affiche dans le panier l'article sélectionné sur la page produit et qui affiche le prix total de la commande
 */
function showShopCart() {

    const myCartJSON = sessionStorage.getItem("myCart")
    const myCart = JSON.parse(myCartJSON)
    let totalPrice = 0

    if (myCart !== null) {

        showFormButton.classList.remove('d-none')
        totalTable.classList.remove('d-none')
        emptyCartText.classList.add('d-none')

        myCart.forEach((element, i) => {

            totalPrice += Number(element.price)
            products.push(element.id)

            const btn = document.createElement('button')
            btn.classList.add('btn', 'btn-danger', 'text-light', 'p-0', 'm-1')
            btn.textContent = "X"
            btn.dataset.index = i
            
            const tr = document.createElement('tr')
            tr.classList.add('col-3', 'name')
            const td1 = document.createElement('td')
            td1.textContent = element.name
            td1.classList.add('col-3')
            const td2 = document.createElement('td')
            td2.classList.add('col-3')
            td2.textContent = element.color
            const td3 = document.createElement('td')
            td3.classList.add('col-3', 'quantity', 'number')
            td3.textContent = element.quantity
            const td4 = document.createElement('td')
            td4.classList.add('col-3')
            td4.textContent = `${element.price / 100},00€`
            const td5 = document.createElement('td')
            td5.appendChild(btn)

            tr.append(td1, td2, td3, td4, td5)
            table.appendChild(tr)
            btn.onclick = (e) => {

                tr.classList.add('d-none')
                myCart.splice(i,i+1)
                products.splice(i,i+1)
                sessionStorage.setItem("myCart", JSON.stringify(myCart))
                totalPrice -= element.price
                const tdPrice = document.getElementById('price')
                tdPrice.innerText = `${totalPrice / 100},00€`
            }
        }); 
    }else{

        emptyCartButton.classList.add('d-none')

    }
    
    showTotalPrice.innerHTML = `&lt;td>&lt;/td>
                                &lt;td>&lt;/td>
                                &lt;td>Total&lt;/td>
                                &lt;td class="number col-3" id="price">${totalPrice / 100},00€&lt;/td>
                                &lt;td>&lt;/td>
                                `
    
}

/**
 * Fonction qui créé l'objet de la requête Post au format attendu (objet de contact et tableau de produits)  et l'envoie à l'API
 * @returns un objet contact, un tableau de produits et un orderId (de type string)
 */
function sendFormRequest() {
    // console.log(postalInput.value + " " + cityInput.value);
    const order = {
        contact: {
            firstName: firstNameInput.value,
            lastName: lastNameInput.value,
            address: addressInput.value,
            city: (postalInput.value + " " + cityInput.value),
            email: mailInput.value
        },
        products: products
    }
    const postTeddies = `http://localhost:3000/api/teddies/order`
    const configPost = {
        method: "POST",
        headers: new Headers({
            "Accept": "application/json",
            "Content-Type": "application/json"
        }),
        body: JSON.stringify(order)
    }

    fetch(postTeddies, configPost)
        .then((response) => response.json())
        .then((data) => sessionStorage.setItem("orderId", JSON.stringify(data)))
        .catch((err) => console.log(err))
}


// VERIFICATION DU FORMULAIRE

/**
 * Fonction qui permet de vérifier les données saisies par l'utilisateur
 * @param {object} input Input ciblé
 * @param {object} regex Expression régulière permettant de vérifier l'input ciblé
 * @param {number} index Ordre dans lequel est affiché l'input sur la page HTML
 */

const testFormConform = (input, regex, index) => {
    if (regex === regexFirstName || regex === regexLastName) {
        
        input.addEventListener('input', (e) => {
            if (regex.test(e.target.value) &amp;&amp; e.target.value.length >= 2) {
                allImg[index].classList.remove("d-none")
                allImg[index].src = "/images/check.svg"
                allSpan[index].classList.add("d-none")
            } else if (!regex.test(e.target.value) || e.target.value.length == 1) {
                allImg[index].classList.remove("d-none")
                allImg[index].src = "/images/error.svg"
                allSpan[index].classList.remove("d-none")
            } else {
                allImg[index].classList.remove('d-none')
            }
        })
    } else {
        input.addEventListener('input', (e) => {
            
            if (regex.test(e.target.value)) {
                allImg[index].classList.remove("d-none")
                allImg[index].src = "/images/check.svg"
                allSpan[index].classList.add("d-none")
            } else if (!regex.test(e.target.value)) {
                allImg[index].classList.remove("d-none")
                allImg[index].src = "/images/error.svg"
                allSpan[index].classList.remove("d-none")
            } else {
                allImg[index].classList.remove('d-none')
            }
        })
    }
}



testFormConform(firstNameInput, regexFirstName, 0)
testFormConform(lastNameInput, regexLastName, 1)
testFormConform(mailInput, regexMail, 2)
testFormConform(addressInput, regexAddress, 3)
testFormConform(postalInput, regexPostal, 4)
testFormConform(cityInput, regexCity, 5)

emptyCartButton.addEventListener('click', deleteItems)

const submitButton = document.querySelector("#true-button")
submitButton.addEventListener('click', (e) => {
    // e.preventDefault()

    if (firstNameInput.value &amp;&amp;
        lastNameInput.value &amp;&amp;
        addressInput.value &amp;&amp;
        cityInput.value &amp;&amp;
        mailInput.value) {
        
        sendFormRequest()
    } else {
        e.preventDefault()
        const warning = document.getElementById('warning')
        warning.classList.remove('d-none')
        setTimeout(() => {
            warning.classList.add('d-none')
          },3000)
        if (!firstNameInput.value) {
            // console.log("prénom non renseigné");
            const warningFirstName = document.querySelector('#warning-firstname').classList
            warningFirstName.remove('d-none')
        }
        if (!lastNameInput.value) {
            // console.log("prénom non renseigné");
            const warningLastName = document.querySelector('#warning-lastname').classList
            warningLastName.remove('d-none')
        }
        if (!mailInput.value) {
            // console.log("prénom non renseigné");
            const warningMail = document.querySelector('#warning-mail').classList
            warningMail.remove('d-none')
        }
        if (!addressInput.value) {
            // console.log("prénom non renseigné");
            const warningAddress = document.querySelector('#warning-address').classList
            warningAddress.remove('d-none')
        }
        if (!postalInput.value) {
            // console.log("prénom non renseigné");
            const warningPostal = document.querySelector('#warning-postal').classList
            warningPostal.remove('d-none')
        }
        if (!cityInput.value) {
            // console.log("prénom non renseigné");
            const warningCity = document.querySelector('#warning-city').classList
            warningCity.remove('d-none')
        }
    }

})

showFormButton.onclick = () => {
    const form = document.querySelector('#facturation-container').classList
    // console.log(form);
    const trueButton = document.querySelector('#true-button').classList
    form.remove('d-none')
    trueButton.remove('d-none')
    showFormButton.classList.add('d-none')
}
showShopCart()</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Projet 5 - Orinoco</a></h2><h3>Global</h3><ul><li><a href="global.html#addCart">addCart</a></li><li><a href="global.html#createCards">createCards</a></li><li><a href="global.html#deleteItems">deleteItems</a></li><li><a href="global.html#requestFetch">requestFetch</a></li><li><a href="global.html#sendFormRequest">sendFormRequest</a></li><li><a href="global.html#showConfirm">showConfirm</a></li><li><a href="global.html#showProduct">showProduct</a></li><li><a href="global.html#showShopCart">showShopCart</a></li><li><a href="global.html#testFormConform">testFormConform</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Wed Sep 15 2021 06:12:13 GMT+0200 (heure normale d’Afrique méridionale)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
